;Spc2Midi - GUI
;============================================================

section .data
align 4
Gui:
.CurrentTime:   dd 0
.Status:        db 0
.StatusActive   equ 1

section .text
;==============================
GuiInit:
    mov eax,13h                 ;set graphics mode 13h
    int 10h
    or byte [Gui.Status],Gui.StatusActive

    mov esi,GuiPalette
    call SetPalette

    call ClearScreen
    push dword MainWindow
    call SendRedrawMsgs         ;redraw all main items, cascading down to each contained item
    add esp,byte 4

    xor eax,eax
    int 16h
    ret

;==============================
GuiDeinit:
    mov eax,3                   ;restore text mode
    int 10h
    and byte [Gui.Status],~Gui.StatusActive
    ret

;==============================
section .data
    dd GuiObj.Null|GuiObj.NoKeyFocus|GuiObj.NoMouseFocus|GuiObj.Hidden|GuiObj.FocusUnaware
    dd -1;NullGuiItem       ;top level has no container
    dd -1;NullGuiItem       ;owner callback
    dd IgnoreMsg            ;item message handler (or intercepting code)
NullGuiItem:

align 4
    ; This is the top of the heirarchy, the container that contains all
    ; others. Technically it can be named anything, since none of it is
    ; hard coded into the GUI routines. No item is aware of anything but its
    ; container and siblings, making things a lot more abstract, and yet,
    ; a lot simpler!
    %define GuiObjContainer NullGuiItem
    MainWindowIdx equ 0
    DefGuiObj MainWindow,WindowCode,NullGuiItem,0, 0,0,Screen.Height,Screen.Width
MainWindow:

    %define GuiObjContainer MainWindow
    %include "guiout.asm"
